/* Peak.java */
/* $Id: Peak.java,v 1.4 2004/09/05 07:27:49 mit Exp $ */
import java.text.DecimalFormat;

public class Peak {
    private int keyn;
    private double freq;
    private double peak;
    private final int OCT = 12;
    private String [] Keynm = 
    {"A..","B..","H..","C..","Cis","D..","Es.","E..","F..","Fis","G..","Gis"};
    private static int counter;
    private DecimalFormat df1 = new DecimalFormat("#0.0##");

    public Peak() {
	setPeak(0, 0, 0);
    }
    public Peak(int kn, double fq, double pk) {
	setPeak(kn, fq, pk);
    }
    public void setPeak(int kn, double fq, double pk) {
	keyn = kn;
	freq = fq;
	peak = pk;
	++counter;
    }
    public String getPeak() {
	StringBuffer str = new StringBuffer(128);

	str.append(df1.format((float)freq));
	str.append(" ");
	str.append(this.getPeakn());
	str.append(": ");
	str.append(df1.format((float)peak));
	str.append("\n");
	
	return str.toString();
    }
    public static void resetPeakt() {
	counter = 0;
    }
    public static void setPeakt(int num) {
	counter += num;
    }
    public static int getPeakt() {
	return counter;
    }
    public String getPeakn() {
	return (keyn+1)+Keynm[keyn%OCT];
    }
    public int getPeakk() {
	return keyn;
    }
    public double getPeakf() {
	return freq;
    }
    public double getPeakp() {
	return peak;
    }
}
