/* $Id: ReadData.java,v 1.1 2004/10/16 06:52:04 mit Exp $ */
import java.io.*;

public class ReadData {
    public class ReadError extends RuntimeException {}

    private Reader input;
    private StreamTokenizer in;
    private int nRows = 2, nCols = 88;

    public ReadData(String filename) {
	try {
	    input = new FileReader(filename);
	}
	catch (FileNotFoundException e) {
	    throw new ReadError();
	}
	in = new StreamTokenizer(input);
	double x = getNum(), y = getNum();
	if (x <= 0 || x > Integer.MAX_VALUE ||
	    y <= 0 || y > Integer.MAX_VALUE) {
	    System.out.println("Not read Rows & Cols.");
	    close();
	    throw new ReadError();
	}
	nRows = (int)x;
	nCols = (int)y;
	//System.err.println(nRows+" Rows: "+nCols+" Cols.");
    }
    public int numOfRows() {
	return nRows;
    }
    public int numOfColumns() {
	return nCols;
    }

    public void close() {
	try {
	    input.close();
	} 
	catch (Exception e) {
	    e.printStackTrace();
	}
    }

    public double getNum() {
	try {
	    for (;;) {
		int ttype = in.nextToken();
		if (ttype == in.TT_EOF) {
		    close();
		    throw new ReadError();
		} else if (ttype == in.TT_NUMBER) {
		    return in.nval;
		} else if (ttype == '*') {
		    return Double.NaN;
		}
	    }
	}
	catch (IOException e) {
	    throw new ReadError();
	}
    }

    public double[] readData() {
	double[] m = new double[nRows*nCols];
	for (int j = 0; j < nRows*nCols; j++)
	    m[j] = getNum();
	close();
	return m;
    }

    public static double[] readData(String filename) {
	return new ReadData(filename).readData();
    }
}
