/* $Id: Recording.java,v 1.2 2007/11/02 12:27:00 mit Exp $
/* Recording.java v0.1 */
import javax.sound.sampled.*;

public class Recording implements Runnable {
    private boolean Runsw;
    private int Buffer;
    private int[] Temp;
    private String Error = "";
    private TargetDataLine tdline;
    private Thread rt;
    private AudioFormat format;
    private Byte2Data BD;

    public Recording() {}
    public Recording(int nn, float rate) {
	BD = new Byte2Data();
	Temp = new int[nn];
        Buffer = nn*2;

	format = new AudioFormat(rate, 16, 1, true, false);
    }

    public void start() {
	rt = new Thread(this);
	rt.start();

	Runsw = true;
    }
    public void stop() {
	if (rt != null)
	    rt = null;

	Runsw = false;	
    }
    public AudioFormat getFormat() {
	return format;
    }
    public boolean isRun() {
        return Runsw;
    }
    public int[] getData() {
        return Temp;
    }

    public void run() {
	Error = null;

	DataLine.Info info = 
	    new DataLine.Info(TargetDataLine.class, format);
	if (!AudioSystem.isLineSupported(info)) {
	    shutDown(info+" not supported.");
	}
	try {
	    tdline = (TargetDataLine)AudioSystem.getLine(info); //1pass-error
	} catch(LineUnavailableException e){
	    shutDown(e.toString());
	} catch(Exception e) {
	    shutDown(e.toString());
	}

	try {
	    tdline.open(format);
	} catch(LineUnavailableException e){
	    shutDown(e.toString());
	}

	tdline.start();
	int nbr;
	byte[] buff = new byte[Buffer];
	while(rt != null) {
	    if ((nbr = tdline.read(buff, 0, Buffer)) == -1)
		break;
	    Temp = BD.byte2data(buff, format);
	}
	tdline.stop();
	tdline.close();
	tdline = null;
    } 

    public void shutDown(String mess) {
	if ((Error = "rec:"+mess) != null && rt != null) {
	    rt = null;
	    System.out.println(Error);
	}
    }
}